* ---------------------------------------------------------------- CR2GS
      Program CR2GS

* Convert CR_USGS files to USGS SMC format

* Sample control file:
*Control file for program CR2GS
*Name of Summary File:
* CR2GS.SUM
*Eq Name:
* Nisqually, WA
*Eq_Code:
* 359
*Origin Time (iyr, imon, iday, ihr, imin):
* 2001 02 28 18 54
*Eq Hypocenter:
* 47.1525, -122.7197
*Depth:
* 52.40
*Moment Magnitude:
* 6.8
*File with station information:
* sta_cr.prn
*Col at which text info starts:
* 113
*Station Filenames:
*ALK0.NIS
*ALK1.NIS
*ALK2.NIS
*ALO0.NIS
*ALO1.NIS
*ALO2.NIS
*stop

* Notes: convert from g to cm/s/s (981.0*acc); 
*        if can't find entry in *.prn, write statement to summary file and go
*        onto the next file.

* File name for output will be constructed by adding "smc" as the extension.


* Dates: 06/03/01 - Written by D. Boore, patterned after UW2GS
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character thead_smc(11)*80, comments(200)*80
      character precision*8

      integer ihead_smc(48)
      real rhead_smc(50)

      real y(100000), t(100000)
      character date_c*8, time_c*11

      character f_ctl*40, f_sum*40, f_in*40, f_out*40, f_sta*40
      character c_stop*4, eq_name*80
      character buf*156, staid_in*4, comp_c*1

      character staid(400)*4, statext(400)*44
      integer   nc_staid(400),  nc_statext(400)
      integer   istacode(400), istasn(400)
      real      stalat(400), stalong(400), staelev(400), sps(400)
      integer   idipch(400,3), iazch(400,3)

      logical f_ctl_exist

      inull = -32768 
      rnull = 1.7e+38

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skip(nu_ctl,2)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call get_lun(nu_sum)
      open(unit=nu_sum,file=f_sum,status='unknown')
      write(nu_sum,'(a)') ' Output of program CR2GS'

      call skip(nu_ctl,1)
      eq_name = ' '
      read(nu_ctl,'(a)') eq_name
      call trim_c(eq_name,nc_eq_name)

      call skip(nu_ctl,1)
      read(nu_ctl,*) ieqcode

      call skip(nu_ctl,1)
      read(nu_ctl,*) iyr, imon, iday, ihr, imin

      call skip(nu_ctl,1)
      read(nu_ctl, *) eqlat, eqlong

      call skip(nu_ctl,1)
      read(nu_ctl, *) eqdepth

      call skip(nu_ctl,1)
      read(nu_ctl, *) eqmag

      call skip(nu_ctl,1)
      f_sta = ' '
      read(nu_ctl,'(a)') f_sta
      call get_lun(nu_sta)
      open(unit=nu_sta,file=f_sta,status='unknown')

      call skip(nu_ctl,1)
      read(nu_ctl, *) icol_strt_statext

      call skip(nu_ctl,1)
     

* Get station info

      i = 0      
      call skip(nu_sta,1)
6666  continue
      buf = ' '
      read(nu_sta,'(a)',end=9999) buf
      nc_buf = 156
      i = i + 1
      nsta = i
      call RCI (1,buf,nc_buf,istacode(i),ibgn,iend,ISTAT)
      call RCC (2,buf,nc_buf,staid(i),NC,ibgn,iend)
      call upstr(staid)
      call trim_c(staid(i),nc_staid(i))
      call RCF (3,buf,nc_buf,stalat(i),ibgn,iend, ISTAT)
      call RCF (4,buf,nc_buf,stalong(i),ibgn,iend, ISTAT)
      call RCF (5,buf,nc_buf,staelev(i),ibgn,iend, ISTAT)
      call RCI (7,buf,nc_buf,istasn(i),ibgn,iend,ISTAT)
      call RCF (8,buf,nc_buf,sps(i),ibgn,iend, ISTAT)
      call RCI (9,buf,nc_buf,idipch(i,1),ibgn,iend, ISTAT)
      call RCI (10,buf,nc_buf,iazch(i,1),ibgn,iend, ISTAT)
      call RCI (11,buf,nc_buf,idipch(i,2),ibgn,iend, ISTAT)
      call RCI (12,buf,nc_buf,iazch(i,2),ibgn,iend, ISTAT)
      call RCI (13,buf,nc_buf,idipch(i,3),ibgn,iend, ISTAT)
      call RCI (14,buf,nc_buf,iazch(i,3),ibgn,iend, ISTAT)
      statext(i) = ' '
      statext(i) = buf(icol_strt_statext:nc_buf)
      call trim_c(statext(i),nc_statext(i))
      go to 6666            
9999  continue
      close(nu_sta)

* Get info for each file

1234  continue

      f_in = ' '
      read(nu_ctl,'(a)') f_in
      call trim_c(f_in, nc_f_in)
      c_stop = ' '
      c_stop = f_in(1:4)
      call upstr(c_stop)
      if(c_stop.eq.'STOP') then
        close(nu_ctl)
        stop
      end if
      nper = index(f_in,'.')
      comp_c = ' '
      comp_c = f_in(nper-1:nper-1)
      read(comp_c,'(i1)') ichn
      ichn = ichn + 1
      
*      write(nu_sum,'(a,1x,i2)') ' For file '//f_in(1:nc_f_in)//
*     :                          ', ichn = ', ichn

      staid_in = ' '
      staid_in = f_in(1:nper-2)
      call upstr(staid_in)
      call trim_c(staid_in,nc_staid_in)
* Find entry in sta info:
      do i = 1, nsta
        if(staid_in(1:nc_staid_in) .eq. staid(i)(1:nc_staid(i))) then
           jsta = i
        write(*,'(a,1x,i3)') ' Reformatting file '//f_in(1:nc_f_in)//
     :       '; jsta = ', jsta
           go to 777
        end if
      end do
      write(nu_sum,'(a)') ' For file '//f_in(1:nc_f_in)//
     :       ' could not find STA info; moving on to next file'
      close(nu_in)
      go to 1234
777   continue
      
* Now open the file and extract the data:
      call get_lun(nu_in)
      open(unit=nu_in,file=f_in,status='unknown')

* Skip header:
      call skip(nu_in,1)

* Read data
  
      npts = 0

2000  continue

      read(nu_in,*,end=4587) t(npts+1), y(npts+1)
* Convert from g to cm/s/s (981.0*acc); 
      y(npts+1) = 981.0*y(npts+1)

      npts = npts + 1
      if ( npts .gt. 100000) then
        write(nu_sum,'(a)') ' For '//f_in(1:nc_f_in)//
     :          ' npts exceeds 100000; moving to next file'
        close(nu_in)
        go to 1234
      end if

      go to 2000
4587  continue
      close(nu_in)

* Check for even spacing of time points:

      eps = 1.0e-04
      do i = 2, npts
        if( abs((t(i) - t(i-1)) - 1.0/sps(jsta)) .gt. eps) then
           write(nu_sum,'(a)') ' For file '//f_in(1:nc_f_in)
           write(nu_sum,'(a,1x,i4,a)') ' For i = ', i,
     :       '  time spacing not equal to 1/sps; moving to next file'
           write(nu_sum,'(a)') 
     :       ' t(i), t(i-1), t(i) - t(i-1) , 1.0/sps = '
           write(nu_sum,*) 
     :         t(i), t(i-1), t(i) - t(i-1) , 1.0/sps(jsta)
           go to 1234
        end if
      end do

* Store null values in headers
      do i = 1, 48
        ihead_smc(i) = inull
      end do

      do i = 1, 50
        rhead_smc(i) = rnull
      end do

* Set up text headers:
      do i = 1, 11
        thead_smc(i) = ' '
      end do
      thead_smc(2) = '*'
      thead_smc(3) = staid(jsta)
      write(thead_smc(4)(6:9),'(i4)') iyr
      write(thead_smc(4)(12:13),'(i2)') imon
      write(thead_smc(4)(16:17),'(i2)') iday
      write(thead_smc(4)(22:23),'(i2)') ihr
      write(thead_smc(4)(24:25),'(i2)') imin
      thead_smc(4)(27:80) = eq_name(1:54)
      thead_smc(5) = 
     :    'Moment Mag=          Ms=          Ml='
      write(thead_smc(5)(12:20),'(f9.2)') eqmag
      thead_smc(6) = 
     :    'station =                                component='

*      write(nu_sum,'(a,1x,i2,a)') 
*     :                   ' for jsta = ', jsta, ' idipch, iazch = '
*      do i = 1, 3
*        write(nu_sum, *) idipch(jsta,i), iazch(jsta,i)
*      end do
*      write(nu_sum,'(a,1x,i2)') ' ichn = ', ichn

      if (idipch(jsta,ichn) .eq. 0) then   ! horizontal
        write(thead_smc(6)(53:57),'(i5)') iazch(jsta,ichn)                  
        ihead_smc(13) = 90
        ihead_smc(14) = iazch(jsta,ichn)
      else if (idipch(jsta,ichn) .eq. -90) then   ! up
        thead_smc(6)(53:54) = 'UP'                  
        ihead_smc(13) = 0
        ihead_smc(14) = iazch(jsta,ichn)
      else if (idipch(jsta,ichn) .eq. +90) then   ! down
        thead_smc(6)(53:56) = 'DOWN'                  
        ihead_smc(13) = 180
        ihead_smc(14) = iazch(jsta,ichn)
      else
        write(nu_sum,'(a,1x,i5,a)') ' For file '//f_in(1:nc_f_in)//
     :    ' idipch = ', idipch(jsta, ichn), ' not a legal value'
        close(nu_in)
        go to 1234
      end if

      thead_smc(7) = 
     :    'epicentral dist ='
* Compute epicentral distance:
      call distaz( -1.0, eqlat,eqlong,stalat(jsta),stalong(jsta),
     :    rdeg, rkm, az, baz)
      write(thead_smc(7)(18:26),'(f9.1)') rkm
      thead_smc(8) = 
     :    'inst type=           data source = CRGS'
               
      do i = 9, 11
        thead_smc(i) = '*'
      end do

* Set up comments:
      comments(1) = '|'
      comments(2) = '| CR_USGS file '//f_in(1:nc_f_in)
      comments(3) = '| Reformatted to SMC format, '//
     :              'using program CR2GS'
      iflag = 0 ! not used by current PC version of datetime; Chris
                ! Stephens would modify datetime.for to include Unix routines
      call datetime(date_c, time_c, iflag)

      comments(4) = 
     :  '|   on '//date_c//' at time '//time_c

      comments(5) = '|'
      ncomments = 5
      comments(ncomments+1) = '|'
      ncomments = ncomments + 1
      comments(ncomments+1) = 
     :  '| Site conditions and structure type from spreadsheet:'
      ncomments = ncomments + 1
      comments(ncomments+1) = '| '//statext(jsta)(1:nc_statext(jsta))
      ncomments = ncomments + 1
      comments(ncomments+1) = '|'
      ncomments = ncomments + 1

* Set up integer headers independent of type of motion:
      ihead_smc(8) = istasn(jsta)
      ihead_smc(16) = ncomments
      ihead_smc(17) = npts
      ihead_smc(31) = 1
      ihead_smc(32) = npts
      ihead_smc(40) = ieqcode
      ihead_smc(41) = istacode(jsta)

* Set up real headers independent of type of motion:
      rhead_smc(2) = sps(jsta)
      rhead_smc(3) = eqlat
      rhead_smc(4) = eqlong
      rhead_smc(5) = eqdepth
      rhead_smc(6) = eqmag
      rhead_smc(11) = stalat(jsta)
      rhead_smc(12) = stalong(jsta)
      rhead_smc(13) = staelev(jsta)
      rhead_smc(17) = rkm
      rhead_smc(18) = az

* Now do motion-specific things (define filenames, using  V1s scheme
* .us1, .us2, .us3, etc; fill rhead(29),..,rhead(32)
* with peak values and times, fill ihead(17) with number of time series 
* values

* Get peak motions:
      
      call mnmaxidx(y, 1, ihead_smc(17), 1,
     :             ymin, ymax, indx_min, indx_max) 
      tmin = float(indx_min-1)/rhead_smc(2)
      tmax = float(indx_max-1)/rhead_smc(2)
      rhead_smc(29) = tmax
      rhead_smc(30) = ymax
      rhead_smc(31) = tmin
      rhead_smc(32) = ymin

      f_out = ' '
      f_out = f_in(1:nper-1)//'.smc'
      itype = 1
      write(*,'(2a)') '  Writing file ', f_out

      precision = ' '
      precision = 'STANDARD'
      ihead_smc(47) = ihead_smc(1)

      call SMCWrite(f_out, precision, y, thead_smc, itype, 
     :                    ihead_smc, rhead_smc, comments)

      go to 1234  ! go to next file

      end
* ---------------------------------------------------------------- CR2GS

      include '\forprogs\notnumrc.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\distaz.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\rc_subs.for'
      include '\forprogs\datetime.for'



          