* ---------------------------------------------------------------- UCA2smc
      Program UCA2smc

* Convert UCA (San Salvador) to USGS SMC format


* Sample control file:
*!Control file for program UCA2SMC
*!Quake_Name
* El Salvador 01/13/2001
*!Eq Hypocenter:
* 13.063, -88.787
*!Yr, Mo, Day, Hr, Min:
* 2001 01 13 17 34
*!Depth:
* 39
*!Moment Magnitude:
* 7.7
*!Station Filenames:
*AR01001U.UCA
*BA01001U.UCA
*EX01001U.UCA
*LI01001U.UCA
*NO01001U.UCA
*PA01001U.UCA
*TE01001U.UCA
*TO01001U.UCA
*ZA01001U.UCA
* stop

* Dates: 08/08/02 - Written by D. Boore, patterned after cdmg2smc.for
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character precision*8
      

      character thead_smc(11)*80, comments(500)*80
      integer ihead_smc(48)
      real rhead_smc(50)

      integer n_ts(3), nc_o(3)
      real damp_ins(3), per_ins(3)

      real ts(:,:)
      allocatable :: ts

      character f_ctl*40, f_in*40, f_out*40, 
     :   comments_ctl(40)*80, comments_uca(27)*80
      character quake_name*54, buf*80
      character sta_name*80, c_orient(3)*12
      character buf_upper*4
      logical f_ctl_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = uca2smc.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'uca2smc.ctl'
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl, comments_ctl, ncomments)

      buf = ' '
      read(nu_ctl, '(a)') buf
      call trim_c(buf,nc_buf)
      nc_qn = min0(nc_buf, 54)
      quake_name = ' '
      quake_name = buf(1:nc_qn)
      write(*,'(2a)') ' quake_name: ', quake_name(1:nc_qn)

      call skipcmnt(nu_ctl, comments_ctl, ncomments)
      read(nu_ctl, *) eqlat, eqlong

      call skipcmnt(nu_ctl, comments_ctl, ncomments)
      read(nu_ctl,*) iyr, imon, iday, ihr, imin

      call skipcmnt(nu_ctl, comments_ctl, ncomments)
      read(nu_ctl, *) depth

      call skipcmnt(nu_ctl, comments_ctl, ncomments)
      read(nu_ctl, *) amommag

      call skipcmnt(nu_ctl, comments_ctl, ncomments)
     
1234  continue

      f_in = ' '
      buf_upper = ' '
      read(nu_ctl,'(a)') f_in
      call trim_c(f_in, nc_f_in)
      buf_upper = f_in(1:4)
      call upstr(buf_upper)
      if(buf_upper(1:4).eq.'STOP') then
        close(nu_ctl)
        stop
      end if

      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_f_in),status='unknown')

      write(*,'(a)') ' Working on file '//f_in(1:nc_f_in)

* Read comments
      do i = 1, 27
        comments_uca(i) = ' '
        read(nu_in,'(a)') comments_uca(i)
      end do

      write(*,'(a)') ' After read comments_uca'

* Extract information from comments.
      sta_name = ' '
      read(comments_uca(14),'(a)') sta_name
      call trim_c(sta_name,nc_sta_name)
      if (nc_sta_name .gt. (40-11)+1) then
        nc_sta_name = (40-11)+1
      end if

      write(*,'(a)') ' Sta_name = '//sta_name(1:nc_sta_name)

      read(comments_uca(15),'(f7.3,1x,f7.3)') stalat, stalong

      write(*,'(a)') ' stalat, stalong = '
      write(*,'(f7.3,1x,f7.3)') stalat, stalong

      call trim_c(comments_uca(22),nc_c22)
      do i = 1, 3
        call RCC (i,comments_uca(22),nc_c22,c_orient(i),
     :            nc_o(i),ibgn,iend)
        call trim_c(c_orient(i),nc_o(i))
        call upstr(c_orient(i))
      end do

      write(*,'(a)') ' After call RCC'
      do i = 1, 3
        write(*,'(a)') ' orient = '//c_orient(i)(1:nc_o(i))
      end do

      read(comments_uca(23), *) dt
!      read(comments_uca(23),'(f5.3)') dt

      sps = 1.0/dt

      write(*,'(a,1x,f6.2)') ' sps = ', sps

      read(comments_uca(24),'(f8.6,1x,f8.6,1x,f8.6)') 
     :  per_ins(1), per_ins(2), per_ins(3)

      write(*,'(a, 1x, f8.6,1x,f8.6,1x,f8.6)') ' per_ins = ',
     :  per_ins(1), per_ins(2), per_ins(3)

      read(comments_uca(25),'(f8.6,1x,f8.6,1x,f8.6)') 
     :  damp_ins(1), damp_ins(2), damp_ins(3)

      write(*,'(a, 1x, f8.6,1x,f8.6,1x,f8.6)')  ' damp = ',
     :  damp_ins(1), damp_ins(2), damp_ins(3)

      read(comments_uca(27),*) an1, an2, an3
      n_ts(1) = an1
      n_ts(2) = an2
      n_ts(3) = an3

!      read(comments_uca(27),'(1x,i6,1x,i6,1x,i6)') 
!     :  n_ts(1), n_ts(2), n_ts(3)

      write(*,'(a, 1x, i5,1x,i5,1x,i5)') ' n_ts = ',
     :  n_ts(1), n_ts(2), n_ts(3)

      write(*,'(a)') ' After extract info from comments_uca'

* Get n_ts for array allocation:

      n_ts_max = max0(n_ts(1), n_ts(2), n_ts(3)) 
*        write(*,'(a)') '  n_ts(1..3), n_ts_max = '
*        write(*,*) (n_ts(i), i =1 ,3),  n_ts_max
        
* To be safe, add 50% more to the array:
*      n_ts_max = 1.5*float(n_ts_max)

* Allocate array:
      n_gm = 3
      allocate (ts(n_ts_max,n_gm))

* Read the time series values and convert to cm/s/s:

      do i = 1, n_ts_max
        read(nu_in,'(1p,3e13.5)') (ts(i,j), j=1,3)
        do j = 1, 3
          ts(i,j) = 981.0*ts(i,j)/10.0  ! convert from g/10 to cm/s/s
        end do
      end do

* For each component:

      do i_c = 1, 3

* Initialize headers:
      do i = 1, 11
        thead_smc(i) = ' '
      end do
      do i = 1, 48
        ihead_smc(i) = -32768
      end do
      do i = 1, 50
        rhead_smc(i) = 1.7e+38
      end do

* Work on text headers (primarily):

      thead_smc(1) = '1 UNCORRECTED ACCELEROGRAM'
      thead_smc(2) = '*'
      thead_smc(3)(1:2) = f_in(1:2)
      write(thead_smc(4)(6:9),'(i4)') iyr 
      write(thead_smc(4)(12:13),'(i2)') imon 
      write(thead_smc(4)(16:17),'(i2)') iday 
      write(thead_smc(4)(22:23),'(i2)') ihr
      write(thead_smc(4)(24:25),'(i2)') imin

      thead_smc(4)(27:80) = quake_name(1:nc_qn)
      thead_smc(5) = 
     :    'Moment Mag=          Ms=          Ml='
      write(thead_smc(5)(12:20),'(f9.2)') amommag
      thead_smc(6) = 
     :    'station =                                component='
      thead_smc(6)(11:40) = sta_name(1:nc_sta_name)

      if (c_orient(i_c)(1:1) .eq. 'N') then
        thead_smc(6)(57:57) = '0'
        ihead_smc(14) = 0
      else if (c_orient(i_c)(1:1) .eq. 'E') then
        thead_smc(6)(56:57) = '90'
        ihead_smc(14) = 90
      else if (c_orient(i_c)(1:1) .eq. 'V') then
        thead_smc(6)(56:57) = 'UP'
        ihead_smc(13) = 0
      else
        write(*,'(a)') ' Error: orientation not N,E, or V; '//
     :         ' c_orient(i_c) = '//c_orient(i_c)(1:nc_o(i_c))
      end if

      thead_smc(7) = 
     :    'epicentral dist ='
* Extract station coordinates and compute hypocentral distance:

      call distaz( -1.0, eqlat,eqlong,stalat,stalong,
     :    rdeg, rkm, az, baz)
      write(thead_smc(7)(18:26),'(f9.1)') rkm
      thead_smc(8) = 
     :    'inst type=           data source =  UCA'
               
      call trim_c(comments_uca(18),nc_18)
      thead_smc(8)(11:15) = comments_uca(18)(1:5)

      do i = 9, 11
        thead_smc(i) = '*'
      end do

* Set up comments:
      comments(1) = '|'
      comments(2) = '| UCA file '//f_in
      comments(3) = '| Reformatted to SMC format, using UCA2smc'
      comments(4) = '|'
      comments(5) = '| Here follow the UCA headers:'
      comments(6) = '|'
      ncomments = 6
* Now add UCA headers as comments:
      do i = 1, 27
        ncomments = ncomments + 1
        comments(ncomments) = '| '//comments_uca(i)(1:78)
      end do

      read(comments_uca(19),*) ihead_smc(8)

      ihead_smc(15) = 120
      ihead_smc(16) = ncomments
      ihead_smc(17) = n_ts(i_c)

      ihead_smc(31) = 1

* Set up real headers independent of type of motion:

      rhead_smc(2) = sps
      rhead_smc(3) = eqlat
      rhead_smc(4) = eqlong
      rhead_smc(5) = depth
      rhead_smc(6) = amommag
      rhead_smc(11) = stalat
      rhead_smc(12) = stalong
      read(comments_uca(15)(17:21),'(f5.0)') rhead_smc(13)
      rhead_smc(17) = rkm
      rhead_smc(18) = az
      rhead_smc(22) = 1.0/per_ins(i_c)
      rhead_smc(23) = damp_ins(i_c)

* Now do motion-specific things (define filenames, using  v2s scheme
* .as1, .as2, .as3, etc; fill rhead(29),..,rhead(32)
* with peak values and times, fill ihead(17) with number of time series 
* values


        ihead_smc(17) = n_ts(i_c)
        ihead_smc(32) = n_ts(i_c)
      
* Get peak motions:
      
        call mnmaxidx(ts(1,i_c), 1, ihead_smc(17), 1,
     :             ymin, ymax, indx_min, indx_max) 
        tmin = float(indx_min-1)/rhead_smc(2)
        tmax = float(indx_max-1)/rhead_smc(2)
        rhead_smc(29) = tmax
        rhead_smc(30) = ymax
        rhead_smc(31) = tmin
        rhead_smc(32) = ymin

        f_out = ' '
        nper = index(f_in(1:nc_f_in),'.')
        f_out(1:nper-3) = f_in(1:nper-3)
        write(f_out(nper-2:nper-2),'(i1)') i_c
        f_out(nper-1:nper+3) = 'u.smc'
        
      precision = ' '
      precision = 'STANDARD'
      ihead_smc(47) = ihead_smc(1)

        itype = 1
        call SMCWrite(f_out, precision,
     :                ts(1,i_c), thead_smc, itype, 
     :                    ihead_smc, rhead_smc, comments)
      end do

      deallocate (ts)

      go to 1234

      end
* ---------------------------------------------------------------- UCA2smc

      include '\forprogs\notnumrc.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\rs2write.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\distaz.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\rc_subs.for'

               